package cours01;

public class Partitions2 {

	public static void main(String[] args) {

		int tabEnt[] = { 7, 2, 1, 8, 4, 13, 8, 7, 3, 5, 6, 8 };

		// n est la taille du problème
		int n = tabEnt.length;
		int P = 2; // nombre de partitions

		// représentation d'une combinaison
		int[] comb = new int[n];
		for (int i = 0; i < n; i++)
			comb[i] = 0;

		// recherche de l'ensemble des combinaisons
		int[] Mcomb = new int[n];
		boolean fin = false;
		int min = diffPartition(tabEnt, comb);
		do {
			int diff = diffPartition(tabEnt, comb);
			if (min > diff) {
				min = diff;
				for (int i = 0; i < n; i++) {
					Mcomb[i] = comb[i];
				}
			}
			fin = suivantPartitionP(comb, P);

		} while (fin == false);

		// affichage du résultat
		for (int i = 0; i < P; i++) {
			System.out.println("Partition " + i + ": ");
			for (int j = 0; j < n; j++) {
				if (Mcomb[j] == i)
					System.out.print(j + ":" + tabEnt[j] + " ");
			}
			System.out.println();
		}

	}

	// calcul de la différence entre la somme des éléments de chaque partition
	public static int diffPartition(int[] tabEnt, int[] comb) {
		int diff = 0;
		for (int i = 0; i < tabEnt.length; i++) {
			if (comb[i] == 1)
				diff += tabEnt[i];
			else
				diff -= tabEnt[i];
		}
		return Math.abs(diff);
	}

	// partition suivante
	public static boolean suivantPartitionP(int[] comb, int P) {
		int i = 0;
		do {
			if (comb[i] == P - 1) {
				comb[i] = 0;
				i++;
			} else {
				comb[i]++;
				break;
			}
		} while (i < comb.length);

		// dernière combinaison tout à vrai
		if (i == comb.length)
			return true;

		return false;
	}
}
